type token =
  | SEMI
  | LBRACE
  | RBRACE
  | LPAREN
  | RPAREN
  | COMMA
  | LBRACK
  | RBRACK
  | LARRAY
  | RARRAY
  | TIMES
  | DIVIDE
  | INCR
  | DECR
  | RANDOM
  | PLUS
  | MINUS
  | GT
  | LT
  | EQ
  | NOTEQ
  | GTEQ
  | LTEQ
  | NOT
  | AND
  | OR
  | DOT
  | ASSIGN
  | INT
  | BOOLEAN
  | STRING
  | GRID
  | ARRAY
  | IF
  | ELSE
  | WHILE
  | FOR
  | RETURN
  | VISIBLE
  | CELL
  | ROW
  | COLUMN
  | SUMROW
  | SUMCOL
  | SUMDIAG
  | MAXROW
  | MAXCOL
  | MAXDIAG
  | MINROW
  | MINCOL
  | MINDIAG
  | CHECKGRID
  | TRUE of (bool)
  | FALSE of (bool)
  | LITERAL of (int)
  | STRINGLITERAL of (string)
  | ID of (string)
  | EOF

val program :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ast.program
